local mod = RW:Boss("Majordomo Executus", "Molten Core")
local L

mod.BossIcon = [[Interface\Icons\achievement_boss_ragnaros]]

---------------------------
-- Variables

-- Spell Reflect
local tReflectDur, wReflect, mReflect

-- Damage Shield
local tShieldDur, wShield, mShield

local RoleBits = RW.Utils.Constants.RoleBits
---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.Win = "Impossible! Stay your attack, mortals... I submit! I submit!"
	end
	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(12018)
	self:SetWin(L.Win)
	
	-- Spell Reflect
	tReflectDur			= self:DurTimer(10, 20619)
	wReflect			= self:CastWarning(20619, nil, nil, RoleBits.CASTER)
	mReflect			= self:CastMessage(20619)
	
	-- Damage Shield
	tShieldDur			= self:DurTimer(10, 21075)
	wShield				= self:CastWarning(21075, nil, nil, bit.bor(RoleBits.MELEE, RoleBits.TANK))
	mShield				= self:CastMessage(21075)
end

---------------------------
-- Locals

-- API Functions

function mod:OnEngage(trigger)
	self:Track("Reflect", 20619)
	self:Track("Shield", 21075)
end

function mod:Reflect(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		tReflectDur:Start()
		wReflect:Show()
		mReflect:Show()
	end
end

function mod:Shield(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		tShieldDur:Start()
		wShield:Show()
		mShield:Show()
	end
end
